using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

namespace GGC_4tables
{
    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public class Form1 : System.Windows.Forms.Form
    {
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
        //private GridRelationDescriptor _tmpDescr = null;
        //private int _tabIndex = 0;
        private ImageList imageList1;
        private IContainer components;

        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        public enum TableDefinition
        {
            One,
            Two,
            Three,
            Four
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridGroupingControl1
            // 
            this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
            this.gridGroupingControl1.Location = new System.Drawing.Point(12, 12);
            this.gridGroupingControl1.Name = "gridGroupingControl1";
            this.gridGroupingControl1.Size = new System.Drawing.Size(339, 352);
            this.gridGroupingControl1.TabIndex = 0;
            this.gridGroupingControl1.Text = "gridGroupingControl1";
            this.gridGroupingControl1.VersionInfo = "3.301.0.0";
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.Images.SetKeyName(0, "open.ico");
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(363, 378);
            this.Controls.Add(this.gridGroupingControl1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Name = "Form1";
            this.Text = "Form1";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Form1());
        }


        private void InitializeGrid()
        {
            GridTableDescriptor parentTD = gridGroupingControl1.TableDescriptor;

            foreach (int eIndex in Enum.GetValues(typeof(TableDefinition)))
            {
                TableDefinition actDef = (TableDefinition)eIndex;
                GridTable actTable = gridGroupingControl1.GetTable(actDef.ToString());
                actTable.TableOptions.AllowDragColumns = true;
                actTable.TableOptions.AllowSortColumns = false;

                GridTableDescriptor childTD = gridGroupingControl1.GetTableDescriptor(actDef.ToString());
                GridTableCellStyleInfo nameStyle = childTD.Columns["A"].Appearance.AnyRecordFieldCell;
                nameStyle.ImageList = imageList1;

                //// Autosize columns
                GridTableModel model = gridGroupingControl1.GetTableModel(actDef.ToString());
                model.ColWidths.ResizeToFit(GridRangeInfo.Table(), GridResizeToFitOptions.IncludeHeaders | GridResizeToFitOptions.IncludeCellsWithinCoveredRange);

                gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(OnQueryCellStyleInfo);
            }
        }

        private void Form1_Load(object sender, System.EventArgs e)
        {
            DataTable dt1 = new DataTable("One");
            dt1.Columns.Add(new DataColumn("A"));
            dt1.Columns.Add(new DataColumn("B"));
            for (int i = 0; i <= 12; i++)
            {
                DataRow newRow = dt1.NewRow();
                newRow["A"] = "This is a test";
                newRow["B"] = "Sample #n";
                dt1.Rows.Add(newRow);
            }
            DataTable dt2 = new DataTable("Two");
            dt2.Columns.Add(new DataColumn("A"));
            dt2.Columns.Add(new DataColumn("B"));
            dt2.Columns.Add(new DataColumn("C"));
            for (int i = 0; i <= 8; i++)
            {
                DataRow newRow = dt2.NewRow();
                newRow["A"] = "Test example #p";
                newRow["B"] = "Test";
                newRow["C"] = "Nice grid";
                dt2.Rows.Add(newRow);
            }
            DataTable dt3 = new DataTable("Three");
            dt3.Columns.Add(new DataColumn("A"));
            dt3.Columns.Add(new DataColumn("B"));
            dt3.Columns.Add(new DataColumn("C"));
            dt3.Columns.Add(new DataColumn("D"));
            for (int i = 0; i <= 8; i++)
            {
                DataRow newRow = dt3.NewRow();
                newRow["A"] = "Test example #p";
                newRow["B"] = "Test";
                newRow["C"] = "Test example #p";
                newRow["D"] = "Test";
                dt3.Rows.Add(newRow);
            }
            DataTable dt4 = new DataTable("Four");
            dt4.Columns.Add(new DataColumn("A"));
            dt4.Columns.Add(new DataColumn("B"));
            dt4.Columns.Add(new DataColumn("C"));
            dt4.Columns.Add(new DataColumn("D"));
            dt4.Columns.Add(new DataColumn("E"));
            for (int i = 0; i <= 8; i++)
            {
                DataRow newRow = dt4.NewRow();
                newRow["A"] = "Test example #p";
                newRow["B"] = "Test";
                newRow["C"] = "Test example #p";
                newRow["D"] = "Test";
                newRow["E"] = "Syncfusion";
                dt4.Rows.Add(newRow);
            }

            DataSet ds = new DataSet();
            ds.Tables.AddRange(new DataTable[] { dt1, dt2, dt3, dt4 });

            this.gridGroupingControl1.DataSource = ds;
            InitializeGrid();


        }


        private void OnQueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            GridGroupingControl actControl = sender as GridGroupingControl;
            GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.Style;
            if (style.TableCellIdentity.TableCellType == GridTableCellType.RecordFieldCell
                || style.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordFieldCell)
            {
                //&& (e.TableCellIdentity.TableCellType != GridTableCellType.AddNewRecordFieldCell)
                GridColumnDescriptor column = style.TableCellIdentity.Column;
                if (column.TableDescriptor.Columns.IndexOf(column) == 0)
                {
                    GridRecordRow rec = e.TableCellIdentity.Table.DisplayElements[e.TableCellIdentity.RowIndex] as GridRecordRow;
                    if (rec != null)
                    {
                        DataRowView dr = rec.GetData() as DataRowView;

                        e.Style.ImageIndex = 0;
                    }
                }
            }
        }



    }
}
